<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>Process R Markdown package from source to installation — process_pkg • pkgpurl</title><script src="../lightswitch.js"></script><script src="../deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="../deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="../deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="../deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="../deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="../deps/headroom-0.11.0/headroom.min.js"></script><script src="../deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="../deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="../deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="../deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="../deps/search-1.0.0/fuse.min.js"></script><script src="../deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="../pkgdown.js"></script><meta property="og:title" content="Process R Markdown package from source to installation — process_pkg"><meta name="description" content="Executes all steps to process an R package written in R Markdown format from source to installation in one go:
Purl all relevant Rmd/*.Rmd files to R/*.gen.R files using purl_rmd().
Re-generate the pkgdown reference index based on the package's main R Markdown file using gen_pkgdown_ref() (if gen_pkgdown_ref = TRUE).
Re-build the package documentation using devtools::document() (if document = TRUE).
Build and install the package (if build_and_install = TRUE). This is done either using
rstudioapi::executeCommand(commandId = &quot;buildFull&quot;) (if use_rstudio_api = TRUE) or using devtools::install() (if
use_rstudio_api = FALSE).
Restarts the R session using rstudioapi::restartSession() (if either restart_r_session = TRUE or use_rstudio_api = TRUE).

"><meta property="og:description" content="Executes all steps to process an R package written in R Markdown format from source to installation in one go:
Purl all relevant Rmd/*.Rmd files to R/*.gen.R files using purl_rmd().
Re-generate the pkgdown reference index based on the package's main R Markdown file using gen_pkgdown_ref() (if gen_pkgdown_ref = TRUE).
Re-build the package documentation using devtools::document() (if document = TRUE).
Build and install the package (if build_and_install = TRUE). This is done either using
rstudioapi::executeCommand(commandId = &quot;buildFull&quot;) (if use_rstudio_api = TRUE) or using devtools::install() (if
use_rstudio_api = FALSE).
Restarts the R session using rstudioapi::restartSession() (if either restart_r_session = TRUE or use_rstudio_api = TRUE).

"><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="../index.html">pkgpurl</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9015</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="active nav-item"><a class="nav-link" href="../reference/index.html">Reference</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="../search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/rpkg.dev/pkgpurl/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-reference-topic">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>Process R Markdown package from source to installation</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/rpkg.dev/pkgpurl/blob/HEAD/R/pkgpurl.gen.R" class="external-link"><code>R/pkgpurl.gen.R</code></a></small>
      <div class="d-none name"><code>process_pkg.Rd</code></div>
    </div>

    <div class="ref-description section level2">
    <p>Executes all steps to process an R package written in R Markdown format from source to installation in one go:</p><ol><li><p>Purl all relevant <code>Rmd/*.Rmd</code> files to <code>R/*.gen.R</code> files using <code><a href="purl_rmd.html">purl_rmd()</a></code>.</p></li>
<li><p>Re-generate the <a href="https://pkgdown.r-lib.org/reference/build_reference.html#reference-index" class="external-link">pkgdown reference index</a> based on the package's <a href="main_rmd.html">main R Markdown file</a> using <code><a href="gen_pkgdown_ref.html">gen_pkgdown_ref()</a></code> (if <code>gen_pkgdown_ref = TRUE</code>).</p></li>
<li><p>Re-build the package documentation using <code><a href="https://devtools.r-lib.org/reference/document.html" class="external-link">devtools::document()</a></code> (if <code>document = TRUE</code>).</p></li>
<li><p>Build and install the package (if <code>build_and_install = TRUE</code>). This is done either using
<code><a href="https://rstudio.github.io/rstudioapi/reference/executeCommand.html" class="external-link">rstudioapi::executeCommand(commandId = "buildFull")</a></code> (if <code>use_rstudio_api = TRUE</code>) or using <code><a href="https://devtools.r-lib.org/reference/install.html" class="external-link">devtools::install()</a></code> (if
<code>use_rstudio_api = FALSE</code>).</p></li>
<li><p>Restarts the R session using <code><a href="https://rstudio.github.io/rstudioapi/reference/restartSession.html" class="external-link">rstudioapi::restartSession()</a></code> (if either <code>restart_r_session = TRUE</code> or <code>use_rstudio_api = TRUE</code>).</p></li>
</ol></div>

    <div class="section level2">
    <h2 id="ref-usage">Usage<a class="anchor" aria-label="anchor" href="#ref-usage"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span><span class="fu">process_pkg</span><span class="op">(</span></span>
<span>  path <span class="op">=</span> <span class="st">"."</span>,</span>
<span>  add_copyright_notice <span class="op">=</span> <span class="fu">pal</span><span class="fu">::</span><span class="fu"><a href="https://pal.rpkg.dev/reference/pkg_config_val.html" class="external-link">pkg_config_val</a></span><span class="op">(</span><span class="st">"add_copyright_notice"</span><span class="op">)</span>,</span>
<span>  add_license_notice <span class="op">=</span> <span class="fu">pal</span><span class="fu">::</span><span class="fu"><a href="https://pal.rpkg.dev/reference/pkg_config_val.html" class="external-link">pkg_config_val</a></span><span class="op">(</span><span class="st">"add_license_notice"</span><span class="op">)</span>,</span>
<span>  gen_pkgdown_ref <span class="op">=</span> <span class="fu">pal</span><span class="fu">::</span><span class="fu"><a href="https://pal.rpkg.dev/reference/pkg_config_val.html" class="external-link">pkg_config_val</a></span><span class="op">(</span><span class="st">"gen_pkgdown_ref"</span><span class="op">)</span>,</span>
<span>  env <span class="op">=</span> <span class="fu"><a href="https://rdrr.io/r/base/sys.parent.html" class="external-link">parent.frame</a></span><span class="op">(</span><span class="op">)</span>,</span>
<span>  document <span class="op">=</span> <span class="cn">TRUE</span>,</span>
<span>  build_and_install <span class="op">=</span> <span class="cn">TRUE</span>,</span>
<span>  restart_r_session <span class="op">=</span> <span class="va">build_and_install</span>,</span>
<span>  use_rstudio_api <span class="op">=</span> <span class="cn">NULL</span>,</span>
<span>  quiet <span class="op">=</span> <span class="cn">TRUE</span>,</span>
<span>  roclets <span class="op">=</span> <span class="cn">NULL</span>,</span>
<span>  args <span class="op">=</span> <span class="fu"><a href="https://rdrr.io/r/base/options.html" class="external-link">getOption</a></span><span class="op">(</span><span class="st">"devtools.install.args"</span><span class="op">)</span>,</span>
<span>  dependencies <span class="op">=</span> <span class="cn">NA</span>,</span>
<span>  upgrade <span class="op">=</span> <span class="st">"never"</span>,</span>
<span>  keep_source <span class="op">=</span> <span class="fu"><a href="https://rdrr.io/r/base/options.html" class="external-link">getOption</a></span><span class="op">(</span><span class="st">"keep.source.pkgs"</span><span class="op">)</span></span>
<span><span class="op">)</span></span></code></pre></div>
    </div>

    <div class="section level2">
    <h2 id="arguments">Arguments<a class="anchor" aria-label="anchor" href="#arguments"></a></h2>


<dl><dt id="arg-path">path<a class="anchor" aria-label="anchor" href="#arg-path"></a></dt>
<dd><p>Path to the root of the package directory.</p></dd>


<dt id="arg-add-copyright-notice">add_copyright_notice<a class="anchor" aria-label="anchor" href="#arg-add-copyright-notice"></a></dt>
<dd><p>Whether or not to add a <strong>copyright notice</strong> at the beginning of the generated <code>.R</code> files as recommended by e.g. the <a href="https://www.gnu.org/licenses/gpl-howto.html" class="external-link">GNU licenses</a>. The notice consists of the name and description of the program and the word <code>Copyright (C)</code> followed by the release years and the name(s) of the copyright holder(s), or if not specified, the author(s). The year is always the current year. All the other information is extracted from the package's <code>DESCRIPTION</code> file. A logical scalar. Only applies if <code>path</code> <a href="https://pal.rpkg.dev/reference/is_pkg_dir.html" class="external-link">is actually an R package directory</a>.</p></dd>


<dt id="arg-add-license-notice">add_license_notice<a class="anchor" aria-label="anchor" href="#arg-add-license-notice"></a></dt>
<dd><p>Whether or not to add a <strong>license notice</strong> at the beginning of the generated <code>.R</code> files as recommended by e.g. the <a href="https://www.gnu.org/licenses/gpl-howto.html" class="external-link">GNU licenses</a>. The license is determined from the package's <code>DESCRIPTION</code> file and currently only the <a href="https://spdx.org/licenses/AGPL-3.0-or-later.html" class="external-link"><code>AGPL-3.0-or-later</code> license</a> is supported. A logical scalar. Only applies if <code>path</code> <a href="https://pal.rpkg.dev/reference/is_pkg_dir.html" class="external-link">is actually an R package directory</a>.</p></dd>


<dt id="arg-gen-pkgdown-ref">gen_pkgdown_ref<a class="anchor" aria-label="anchor" href="#arg-gen-pkgdown-ref"></a></dt>
<dd><p>Whether or not to overwrite <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a>'s <a href="https://pkgdown.r-lib.org/reference/build_reference.html#reference-index" class="external-link">reference index</a> in the configuration file <code>_pkgdown.yml</code> with an auto-generated one based on the main input file as described in <code><a href="gen_pkgdown_ref.html">gen_pkgdown_ref()</a></code>. A logical scalar. Only applies if <code>path</code> <a href="https://pal.rpkg.dev/reference/is_pkg_dir.html" class="external-link">is actually an R package directory</a>, <a href="https://pal.rpkg.dev/reference/is_pkgdown_dir.html" class="external-link">pkgdown is set up</a> and a <a href="main_rmd.html">main R Markdown file</a> exists.</p></dd>


<dt id="arg-env">env<a class="anchor" aria-label="anchor" href="#arg-env"></a></dt>
<dd><p>Environment to evaluate R Markdown inline code expressions in when generating the pkgdown reference index. Only relevant if
<code>gen_pkgdown_ref = TRUE</code>.</p></dd>


<dt id="arg-document">document<a class="anchor" aria-label="anchor" href="#arg-document"></a></dt>
<dd><p>Whether or not to re-build the package documentation after purling <code>Rmd/*.Rmd</code> to <code>R/*.gen.R</code>.</p></dd>


<dt id="arg-build-and-install">build_and_install<a class="anchor" aria-label="anchor" href="#arg-build-and-install"></a></dt>
<dd><p>Whether or not to build and install the package after purling <code>Rmd/*.Rmd</code> to <code>R/*.gen.R</code>.</p></dd>


<dt id="arg-restart-r-session">restart_r_session<a class="anchor" aria-label="anchor" href="#arg-restart-r-session"></a></dt>
<dd><p>Whether or not to restart the R session. Highly recommended if <code>build_and_install = TRUE</code>, but only possible when R is run within
RStudio. Note that the R session is always restarted if <code>use_rstudio_api = TRUE</code>.</p></dd>


<dt id="arg-use-rstudio-api">use_rstudio_api<a class="anchor" aria-label="anchor" href="#arg-use-rstudio-api"></a></dt>
<dd><p>Whether or not to rely on the RStudio API to install the built package (which always triggers an R session restart regardless of
<code>restart_r_session</code>). If <code>NULL</code>, the RStudio API is automatically used if possible, i.e. RStudio is running. Note that installation without the RStudio API
has known issues, see section <em>Details</em> below for further information.</p></dd>


<dt id="arg-quiet">quiet<a class="anchor" aria-label="anchor" href="#arg-quiet"></a></dt>
<dd><p>Whether or not to suppress printing status output from internal processing.</p></dd>


<dt id="arg-roclets">roclets<a class="anchor" aria-label="anchor" href="#arg-roclets"></a></dt>
<dd><p>Character vector of roclet names to use with package.
The default, <code>NULL</code>, uses the roxygen <code>roclets</code> option,
which defaults to <code>c("collate", "namespace", "rd")</code>.</p></dd>


<dt id="arg-args">args<a class="anchor" aria-label="anchor" href="#arg-args"></a></dt>
<dd><p>An optional character vector of additional command line
arguments to be passed to <code>R CMD INSTALL</code>. This defaults to the
value of the option <code>"devtools.install.args"</code>.</p></dd>


<dt id="arg-dependencies">dependencies<a class="anchor" aria-label="anchor" href="#arg-dependencies"></a></dt>
<dd><p>Which dependencies do you want to check?
Can be a character vector (selecting from "Depends", "Imports",
"LinkingTo", "Suggests", or "Enhances"), or a logical vector.</p>
<p><code>TRUE</code> is shorthand for "Depends", "Imports", "LinkingTo" and
"Suggests". <code>NA</code> is shorthand for "Depends", "Imports" and "LinkingTo"
and is the default. <code>FALSE</code> is shorthand for no dependencies (i.e.
just check this package, not its dependencies).</p>
<p>The value "soft" means the same as <code>TRUE</code>, "hard" means the same as <code>NA</code>.</p>
<p>You can also specify dependencies from one or more additional fields,
common ones include:</p><ul><li><p>Config/Needs/website - for dependencies used in building the pkgdown site.</p></li>
<li><p>Config/Needs/coverage for dependencies used in calculating test coverage.</p></li>
</ul></dd>


<dt id="arg-upgrade">upgrade<a class="anchor" aria-label="anchor" href="#arg-upgrade"></a></dt>
<dd><p>Should package dependencies be upgraded? One of "default", "ask", "always", or "never". "default"
respects the value of the <code>R_REMOTES_UPGRADE</code> environment variable if set,
and falls back to "ask" if unset. "ask" prompts the user for which out of
date packages to upgrade. For non-interactive sessions "ask" is equivalent
to "always". <code>TRUE</code> and <code>FALSE</code> are also accepted and correspond to
"always" and "never" respectively.</p></dd>


<dt id="arg-keep-source">keep_source<a class="anchor" aria-label="anchor" href="#arg-keep-source"></a></dt>
<dd><p>If <code>TRUE</code> will keep the srcrefs from an installed
package. This is useful for debugging (especially inside of RStudio).
It defaults to the option <code>"keep.source.pkgs"</code>.</p></dd>

</dl></div>
    <div class="section level2">
    <h2 id="value">Value<a class="anchor" aria-label="anchor" href="#value"></a></h2>
    <p><code>path</code>, invisibly.</p>
    </div>
    <div class="section level2">
    <h2 id="details">Details<a class="anchor" aria-label="anchor" href="#details"></a></h2>
    <p>Note that the installation via <code><a href="https://devtools.r-lib.org/reference/install.html" class="external-link">devtools::install()</a></code> (i.e. <code>use_rstudio_api = FALSE</code>) is known to fail in certain situations (lazy-load database corruption)
due to <a href="https://bugs.r-project.org/show_bug.cgi?id=16644" class="external-link">unresolved deficiencies</a> in <span style="R">R</span>'s namespace unloading. If you encounter an error, simply restart the
<span style="R">R</span> session and try again.</p>
<p>This function is registered as an <a href="https://rstudio.github.io/rstudioaddins/" class="external-link">RStudio add-in</a>, allowing RStudio users to assign a <a href="https://support.rstudio.com/hc/en-us/articles/206382178-Customizing-Keyboard-Shortcuts-in-the-RStudio-IDE" class="external-link">custom shortcut</a> to it and to invoke it from the <a href="https://www.rstudio.com/blog/rstudio-1-4-a-quick-tour/#command-palette--shortcuts" class="external-link">command palette</a>.</p>
    </div>
    <div class="section level2">
    <h2 id="see-also">See also<a class="anchor" aria-label="anchor" href="#see-also"></a></h2>
    <div class="dont-index"><p>Other high-level functions:
<code><a href="lint_rmd.html">lint_rmd</a>()</code>,
<code><a href="load_pkg.html">load_pkg</a>()</code>,
<code><a href="purl_rmd.html">purl_rmd</a>()</code>,
<code><a href="run_nopurl_rmd.html">run_nopurl_rmd</a>()</code></p></div>
    </div>

  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.</p>
</div>

    </footer></div>





  </body></html>

